var usernameTypes = ["text", "email", "tel", "number"];
var usernameHints = ["账号","邮箱","手机号","电子邮件","用户名","username","phone","email","账户"];
function isUsername(element) {
  for (let x in usernameTypes) {
    if (element.type === usernameTypes[x]) {
      return true;
    }
  }
  var htmlString = new String(element.outerHTML).toLowerCase();
  for (let z in usernameHints){
    if(htmlString.indexOf(usernameHints[z]) !== -1){
        return true;
    }
  }
  return false;
}

var passwordHints = ["密码", "password", "pwd"];
function isPassword(element) {
  var htmlString = new String(element.outerHTML).toLowerCase();
  switch (element.type) {
    case "password": return true;
    case "text":
    case "number":
      for (let y in passwordHints) {
        if (htmlString.indexOf(passwordHints[y]) !== -1) {
          return true;
        }
      }
    default:
      return false;
  }
}

function getElementId(element,isPwd) {
  if (element.id === "") {
    let timestamp = new Date().getTime();
    if(isPwd){
        timestamp+="pass";
    }else{
        timestamp+="name";
    }
    element.id = timestamp;
  }
  return element.id;
}

function isVisible(element) {
  var style = window.getComputedStyle(element, null);
  return style.display !== "none" && style.visibility !== "hidden";
}

var inputs = document.getElementsByTagName("input");
var formIdPair = ["",""];
for (var i = 0; i < inputs.length; i++) {
  if (isPassword(inputs[i]) && isVisible(inputs[i])) {
    formIdPair[1] = getElementId(inputs[i],true);
    for (var j = i - 1; j >= 0; j--) {
      if (isUsername(inputs[j]) && isVisible(inputs[j])) {
        formIdPair[0] = getElementId(inputs[j],false);
        break;
      }
    }
    break;
  }
}
JsInterface.onFindFormResult(formIdPair[0]+"&&&"+formIdPair[1]);

